# širinski obilazak usmjerenog acikličkog grafa - širinski_obilazak.py
from klasaUsmjereniGraf import *

def BFS(n, grane, ime):
    graf = UsmjereniGraf(n, grane, ime)
    red = []                                                           
    posjeceni = [0] * n                                                 
    for i in range(n):
        if len(graf.nep_pret[i]) == 0:
            red.append(i)                                               
            posjeceni[i] = 1								 
    print('Širinskim obilaskom posjećeni su čvorovi sljedećim redom:')
    while len(red) != 0:
        m = red.pop(0)                                                  
        print(m, end = '  ')
        for k in graf.nep_sljed[m]:                                    
            if not posjeceni[k]:
                red.append(k)                                           
                posjeceni[k] = 1
    return

def main():
    ime = 'graf_a'
    n = 11
    grane = [(0, 2), (0, 3), (0, 4), (1, 4), (1, 5),
             (2, 6), (2, 7), (2, 8), (3, 8), (5, 9), (7, 10)]
    BFS(n, grane, ime)
    
main()
