#dubinski obilazak usmjerenog acikličnog grafa - dubinski_obilazak.py
from klasaUsmjereniGraf import *

def DFS(n, grane, ime):
    graf = UsmjereniGraf(n, grane, ime)
    stog = []                                                           
    posjeceni = [0] * n                                                
    for i in range(n):                                      
        if len(graf.nep_pret[n - i - 1]) == 0:                          
            stog.append(n - i - 1)                                      
            posjeceni[n - i - 1] = 0
    print('Dubinskim obilaskom posjećeni su čvorovi sljedećim redom:')
    while len(stog) != 0:
        m = stog.pop()                                                  
        print(m, end = '  ')
        a = graf.nep_sljed[m]                                         
        a.reverse()
        for t in a:                                                     
            if not posjeceni[t]:
                stog.append(t)                                          
                posjeceni[t] = 1
    return

def main():
    ime = 'graf_a'
    n = 11
    grane = [(0, 2), (0, 3), (0, 4), (1, 4), (1, 5), 
             (2, 6), (2, 7), (2, 8), (3, 8), (5, 9), (7, 10)]
    DFS(n, grane, ime)

main()
