from Queue import *
from matrica import *

##funkcija vraća sve pozicije do kojih je moguće
##doći izravno iz pozicije x, y
def susjedi(p):
    x, y = p[0], p[1]
    ##lista svih relativnih pomaka
    d = [[-2, -1], [-1, -2], [1, -2], [2, -1], [-2, 1], [-1, 2], [1, 2], 
        [2, 1]]
    ##za sve okolne pozicije provjeravamo jesu li unutar ploče
    for t in d:
        if 0 <= x + t[0] < 8 and 0 <= y + t[1] < 8:
            yield x + t[0], y + t[1]

def main():
    p = input()
    z = input()
    a = Matrica(8, 8)
    ##Vrijednosti elemenata matrice postavljamo na -1
    for i in range(8):
        for j in range(8):
            a[i, j] = -1
    ##računamo redak i stupac matrice na osnovu pozicije
    x, y = int(p[1]) - 1, ord(p[0]) - 65
    a[x, y] = 0
    r = Queue()
    ##početnu poziciju stavljamo na red
    r.enqueue((x, y))
    while not r.isEmpty():
        ##Uzimamo poziciju prvog polja s reda
        x = r.dequeue()
        k = a[x]
        ##Prolazimo po svim poljima do kojih možemo izravno doći iz x
        for t in susjedi(x):
            ##ukoliko još nismo bili na polju
            if a[t] == -1:
                a[t] = k + 1
                r.enqueue(t)
    x, y = int(z[1]) - 1, ord(z[0]) - 65
    print(a[x, y])

main()
