from klasaTeGraf import *

def prema_najbližem(graf, poč_čvor):
    graf2 = graf.kopiraj()                                      
    obilazak = []                                               
    trenutni = poč_čvor                             
    udaljenost = 0                                                                          
    while len(obilazak) < graf2.n - 1:                          
        najbliži = graf2.najblizi_susjed(trenutni)              
        udaljenost += graf2[trenutni, najbliži]
        for i in range(graf2.n):                                
            graf2[trenutni, i] = float('inf')
            graf2[i, trenutni] = float('inf')
        obilazak.append((trenutni, najbliži))                   
        trenutni = najbliži
    udaljenost += graf[trenutni, poč_čvor]
    obilazak.append((trenutni, poč_čvor))
    return obilazak, udaljenost

def main():
    n = 5
    grane_s_težinama = {(0,1): 100, (0,2): 30, (0,3): 130, (0,4): 160,
                        (1,2): 60, (1,3): 110, (1,4): 200,
                        (2,3): 90, (2,4): 150, (3,4): 120}
    graf = TeGraf(n, grane_s_težinama)                                               
    print('Težinska matrica grafa')
    print(graf)
    for i in range(n):                                               
        put, udaljenost = prema_najbližem(graf, i)              
        print('Početni čvor: {0}'.format(i), end = '; ')
        print('put: {0}'.format(put), end = '; ')
        print('duljina: {0}'.format(udaljenost))
                          
main()    
