from datetime import *
class Datum(date):
    def __init__(self, y, m, d):
        super().__init__()
        return

    def __sub__(self, d):
        a = self.toordinal()
        b = d.toordinal()
        return a - b

    def __add__(self, n):        
        return Datum.fromordinal(self.toordinal() + n)

    def __repr__(self):
        d, m, y = str(self.day), str(self.month), str(self.year)
        if len(d) == 1:
            d = '0' + d
        if len(m) == 1:
            m = '0' + m
        while len(y) < 4:
            y = '0' + y
        return '{0}.{1}.{2}.'.format(d, m, y)

    def __str__(self):
        return self.__repr__()

class Ucenik:
    def __init__(self, ime, prezime, dr):
        self.I = ime
        self.P = prezime
        self.D = dr
        return

    def __repr__(self):
        return '{0}\t{1}\t{2}'.format(self.I, self.P, self.D)    

class Razred:
    def __init__(self, o = '', u = []):
        self.O = o
        ##Popis učenika čuvamo u listi
        self.U = u
        return

    def dodajUcenika(self, uc):
        self.U.append(uc)
        return

    def sortiraj(self, N = 'I'):
        if N == 'I':
            self.U = sorted(self.U, key = lambda u : u.I)
        elif N == 'P':
            self.U = sorted(self.U, key = lambda u : u.P)
        else:
            self.U = sorted(self.U, key = lambda u : u.D)
        return

    def __repr__(self):
        s = '{0}\n{1}\n'.format(self.O, '=' * 30)
        for t in self.U:
            s += '{0}\n'.format(t)
        return s
