def binarno_traženje(e, a):
    '''Funkcija vraća vrijednost indeksa prvog elementa u listi
     čija je pripadna vrijednost jednaka e ili 
      -1 ako ne postoji element s tom vrijednošću u listi'''
    početak, kraj = 0, len(a) - 1
    while početak <= kraj:
        sredina = početak + (kraj - početak) // 2
        if a[sredina] == e:
            return sredina
        elif a[sredina] > e:
            kraj = sredina - 1
        else:
            početak = sredina + 1
    return -1
