def binarno_traženje_r(e, a, početak = 0, kraj = None):
    '''Rekurzivna funkcija vraća vrijednost indeksa prvog elementa u listi
    čija je pripadna vrijednost jednaka e ili -1  ako ne postoji element s
    tom vrijednošću u listi'''
    if kraj == None:
        kraj = len(a) - 1
    if početak > kraj:
        return -1
    else:
        sredina = početak + (kraj - početak) // 2        
        if a[sredina] == e:
            return sredina
        elif a[sredina] > e:
            return binarno_traženje_r(e, a, početak, sredina - 1)
        else:
            return binarno_traženje_r(e, a, sredina + 1, kraj)
