# Topološko sortiranje grafa
from klasaUsmjereniGraf import *
def topsort(ugraf):
    '''Funkcija za usmjereni graf ugraf vraća novi graf koji
    je topološki sortiran'''
    red = []                                                           
    posjeceni = [0] * ugraf.n                                                
    for i in range(ugraf.n):
        if len(ugraf.nep_pret[i]) == 0:
            red.append(i)                                           
            posjeceni[i] = 1
    novi_indeksi = [0 for i in range(ugraf.n)]                          
    ind = 0                                                             
    while len(red) != 0:
        m = red.pop(0)                                                  
        novi_indeksi[m] = ind                                           
        ind += 1
        for k in ugraf.nep_sljed[m]:                                    
            if not posjeceni[k]:
                red.append(k)                                           
                posjeceni[k] = 1
    nove_grane = []
    for par in ugraf.grane:
        nove_grane.append((novi_indeksi[par[0]], novi_indeksi[par[1]])) 
    return UsmjereniGraf(ugraf.n, nove_grane)
